c....&................................................................72
      implicit none
      integer nlg_hr,nlt_hr,nlg_lr,nlt_lr,npix,ipix,m,ilg,ilt,klg,klt
      integer neig_lg,neig_lt,num,ilg_hr,ilt_hr
c  npix : number of pixels (to be changed by user)      
      parameter (npix=171803,nlg_hr=2400,nlt_hr=3000)
      integer isu,isu_hr(nlg_hr,nlt_hr),num_isu(1000),iii,k,num_line
     &      ,num_isumax
      real*4 xlg,xlt,var(5),fl
      real*4 xlgmin,xltmin,dlg_hr,dlt_hr
      real*4 xlg_hr(nlg_hr),xlt_hr(nlt_hr),var_hr(nlg_hr,nlt_hr,5)
     &      ,fl_hr(nlg_hr,nlt_hr)
      real*4 areal,parea,pi,fland,areatot,sumtxt

c  name of input file for the mean (to be changed by user)      
      open(1,file=
     &'../clim/Belgium/WC2/'
     &//'ecotxt.dat')
     
      pi=3.141592654
     
      neig_lg = 12
      neig_lt = 8

c  xlgmin, xltmin : minimum longitude and latitude of the zone 
c                  (to be changed by user)      
      
      xlgmin=1.75
      xltmin=49.25 
      dlg_hr=1./120.
      dlt_hr=1./120.      
      
      do ilg=1,nlg_hr
       xlg_hr(ilg)=xlgmin+(float(ilg)-0.5)*dlg_hr
      end do
      do ilt=1,nlt_hr
       xlt_hr(ilt)=xltmin+(float(ilt)-0.5)*dlt_hr
      end do  
      
      do ilg=1,nlg_hr
       do ilt=1,nlt_hr
        do m=1,5
         var_hr(ilg,ilt,m)=-9999. 
	end do
	isu_hr(ilg,ilt)=-999
	fl_hr(ilg,ilt)=-999	
       end do
      end do       
     
      do ipix = 1, npix
       read(1,*)iii,xlg,xlt,isu,(var(m),m=1,5),fl
       ilg = 1 + int((xlg-xlgmin)/dlg_hr)
       ilt = 1 + int((xlt-xltmin)/dlt_hr)
       do m = 1, 5
        var_hr(ilg,ilt,m)=var(m)
       end do
       isu_hr(ilg,ilt)=isu
       fl_hr(ilg,ilt)=fl
      end do
      
      close (1)

c  name of output file for the mean (to be changed by user)      
      open(2,file=
     &'../clim/Belgium/WC2_4min/'
     &//'ecotxt.dat')

      num_line= 0
      
      do ilt = 1, nlt_hr, neig_lt      
       do ilg = 1, nlg_hr, neig_lg
         num = 0
	 areal = 0.
	 areatot = 0.
         do m=1,5
	  var(m)=0.
	 end do
	 do k=1,1000
	  num_isu(k)=0
	 end do
         do klg = 1, neig_lg
	  do klt = 1, neig_lt
	   ilg_hr = ilg+klg-1
	   ilt_hr = ilt+klt-1
	   if ((ilg_hr.le.nlg_hr).and.(ilt_hr.le.nlt_hr)) then
	    parea=1.23604306d+10*dlg_hr*dlt_hr
     &            *cos(xlt_hr(ilt_hr)*pi/180.)*fl_hr(ilg_hr,ilt_hr)
            areatot=areatot+parea	   
	    if (var_hr(ilg_hr,ilt_hr,1).gt.-9000.) then
	     num=num+1
             areal = areal+parea
	     do m = 1, 5
	      var(m) = var(m)+var_hr(ilg_hr,ilt_hr,m)*parea
	     end do
	     isu = isu_hr(ilg_hr,ilt_hr)
	     num_isu(isu)=num_isu(isu)+1	     
	    endif
	   endif
	  end do
	 end do
	 if (num.ge.1) then
	     num_line = num_line + 1
	     fland = areal/areatot 
	     do m = 1, 5
	      var(m) = var(m)/areal
	     end do
	     num_isumax=-999
	     do k = 1, 1000
	      if (num_isu(k).gt.num_isumax) then
	        num_isumax=num_isu(k)
		isu = k
	      endif
	     end do	     	     
	     sumtxt=var(1)+var(2)+var(3)
	     if (abs(100.-sumtxt).ge.0.02)var(2)=100.-var(1)-var(3)
	     if (var(5).lt.0.) var(5)=0.
	     if (var(5).gt.1.) var(5)=1.
	     xlg = (xlg_hr(ilg)+xlg_hr(ilg+neig_lg-1))/2.	   
	     xlt = (xlt_hr(ilt)+xlt_hr(ilt+neig_lt-1))/2.
	     write(2,123)num_line,xlg,xlt,isu,(var(m),m=1,5),fland
         endif
       end do
      end do
      
123   format(i7,2(1x,f9.4),1x,i3,3(1x,f6.2),1x,f5.0,1x,f5.2,1x,f6.3)
      
       
      
      stop
      end      
       
      
