c....&...1.........2.........3.........4.........5.........6.........7..
      implicit none
      integer nlon,nlat,nlines,i,j
c number of longitudes and latitudes of the RCM
      parameter (nlon=594,nlat=454)
      real*4 xlon(nlon),xlat(nlat)
      real*4 xlgmin,xlgmax,xltmin,xltmax
c *3 = number of characters in the name of longitude vector (lon, X)
c      in the netcdf file
      character*3 clon
c *3 = number of characters in the name of latitude vector (lat, Y)
c      in the netcdf file      
      character*3 clat
      character*1 char
      character*200 filRCM,filout

c min & max longitudes, latitudes of the target zone to be extracted
c   (i.e., of the ecotxt high resolution file of the region)      

c Luxemburg 
      xlgmin = 5.75  !5.7
      xlgmax = 6.55  !6.6  
      xltmin = 49.45 !49.4 
      xltmax = 50.15 !50.2

c reading RCM longitudes and latitudes coordinates from file filRCM obtained with
c     ncdump -c <netcdf filename.nc> 

c nlines = number of lines of the file header and/or time vector (not to be read)      
      nlines = 2345

c input file (filRCM)      
      filRCM='./coord_cosmo.txt'
      
c output file (filout)      
      filout='../clim/Luxemburg/COSMO/coordinates.dat'      
      
c==========================================================================      
      
      open(1,file=trim(filRCM))
      
      do i=1,nlines
       read(1,*) 
      enddo 
      
      read(1,*)clon,char,xlon
      
      read(1,*)
      
      read(1,*)clat,char,xlat
      
c      write(*,*)'Longitudes: '
c      write(*,*)(xlon(i),i=1,nlon)
      
c      write(*,*)'Latitudes: '
c      write(*,*)(xlat(i),i=1,nlat)
      
      close (1)
      
c extraction and printing  of longitude/latitude values of the RCM pixels 
c located in the target zone 

      open(10,file=trim(filout))

      do i=1,nlon
       if ((xlon(i).ge.xlgmin).and.(xlon(i).le.xlgmax)) then 
        do j=1,nlat     
         if ((xlat(j).ge.xltmin).and.(xlat(j).le.xltmax)) then
           write(10,*)xlon(i),xlat(j)
	 endif
	end do
       endif
      end do
	   
      close (10)

      stop
      end      
                 
